# =========================================================================== #
# Changelog: Installer.rb
# =========================================================================== #
# 03.11.2005
#  - started RSourceMaker.rb 
#  - Added ability to show dependencies from commandline.
#
# 10.11.2005
#  - Changed behaviour by adding Abbrev for global aliases, and also  
#    to check the case ARGV[1] only when ARGV[1] is not nil. Also moved 
#    commandline feedback into small defs and ry programname_shortcut 
#    all now gives you all the needed info you want.
# 
#    Example for using this:
#      ry fluxbox all
#
# 05.12.2005
#  - It is now possible to auto-download source files from the web.
#    This is done like so:
#      ry xfce download  
#    Instead of "download" you can use dl, down, wget etc. as keywords.
#
# 15.12.2005
#  - Added Option to display ./configure options.
#
# 23.12.2005
#  - Created RYamlSourceWrapper
#
# 28.12.2005
#  - Fixed a bug that created /Programs/Wesnoth instead of
#    /Programs/Games/Wesnoth. Reason for the bug was calling
#    my_cap, which lead to Wesnoth instead of wesnoth, and thus
#    couldnt find it in the array that contained which programs
#    we kept.
#
# 02.01.2006
#  - Fixed old mispointing yaml entry about chained programs.
#
# 05.01.2006
#  - Added @use_another_prefix to denote stuff like
#    @use_another_prefix="/usr/test"
#
# 06.01.2006
#  - Added @installs_these_binaries (later changed to just @binaries)
#
# 09.01.2006
#  - There was some bug which did break the installation of
#    automated packages. Tracking it down took some hours :(
#
# 14.01.2006 (BIG CHANGE)
#  - Splitted yaml-init data into a new class (and file). Now this
#    other class handles all the data, and this class here handles
#    installation of stuff.
#
# 27.01.2006
#  - Fixed a bug that used old syntax (in download_program)
#
# 02.02.2006
#  - Got annoyed about serious bugs. From now on I would prefer to
#    ALWAYS lowercase names of programs in the database. I dont care
#    about '-' in the names, only about characters being lowercased.
#    Arent conventions good if they DO make your life easier without
#    tying you to stupid things?
#
# 25.02.2006
#  - Added extract_to in RYamlLoader, and add the required code here
#    in RSourceMaker to use this info too. This is needed for fluxbox
#    mods for instance.
#
# 28.02.2006
#  - Changed LOG_TO_WHICH_FILE to use 
#      /System/Information/InstalledSourceFiles.html
#    I dont like to keep stray files at all.
#
# 04.03.2006
#  - Created RConfigure and changed references.
#
# 10.03.2006
#  - Changed invocation of RConfigure, now it is handled via a
#    method. Out-factored the logging capability into its own
#    method. Made installing via traditional way its own method.
#    I did a lot of small changes, and I think RSourceMaker.rb
#    is now a lot better, using many more methods which can be
#    more easily changed than those huge methods prior to that
#    change.
#
# 11.03.2006
#  - Removed @install_everything_with_prefix_usr
#    Its not needed because we can just as easily use 
#    @use_prefix nowadays.
#
# 15.03.2006
#  - enabled override. Things should go easier now.
#
# 04.04.2006
#  - Added Paco as option.
#
# 11.04.2006
#  - Wrote RDcopWrapper.rb, which is a wrapper towards the KDE dcop
#    functionality (and eventually was renamed to rdcop.rb and was
#    removed from this project). Now, in konsole, you can automatically
#    have the name of the installed program as the konsole title.
#    I love this. Am vVery proud of myself now!
#    There was a reason for this too, because in the middle of compilation,
#    I sometimes had no idea which program was currently installed. Thus,
#    now with the title set, you immediately know which application
#    is currently installed or compiled. (In Dec 2013 I have finally
#    removed rdcop altogether).
#
# 13.04.2006
#  - Added the string @information_about_last_compiled_program
#    This string contains the information about the program 
#    which was last compiled. 
#
# 25.04.2006
#  - Changed to LOG_DETAILED_INSTALLED_SOURCE_FILES_HTML
#
# 05.05.2006
#  - Added a way to autogenerate a .yml file about the last 
#    compiled program.
#
# 15.05.2006
#  - Switched from wget to open-uri. (Yay!)
#
# 21.05.2006
#  - Implemented rudimentary binary installation.
#    Reworked InstallPackage.rb concept. Anyway, since today you 
#    can use my scripts to install binary programs onto your 
#    system. To install a binary, use this for example:
#      ry gcc binary
#
# 02.06.2006
#  - Added ability to create and insert data into a sqlite3
#    database. (This is purely optional!).
#
# 04.07.2006
#  - Moved sqlite3 interception to a more logical point, ie
#    only insert when we REALLY are about to compile a program. 
#
# 07.07.2006
#  - Implemented to check for existing configure script before
#    trying to compile.
#
# 11.07.2006
#  - Added possibility to search repository for certain strings.
#
# 23.07.2006
#  - Added docu === tags and made it possible to apply rconf
#    even if you need to change to a subdir.
#
# 29.08.2006
#  - Deprecated commandline ArgvSplitter, so a lot of code
#    breaks in here... have to rework many parts. *sigh*
#
# 16.09.2006
#  - Added chained compiling. Now you can compile php including 
#    its dependencies, and the dependencies of these 
#    dependencies, in one go, for example.
#
# 27.09.2006
#  - Fixed a bug in search. Now it looks better, and displays
#    nicer description. Try it :)
#      ry python search
#
# 02.10.2006
#  - Added md5sum finally. Usage example:
#      ry sdl md
#
# 24.10.2006
#  - Finally removed all-deps, and now have only one dependency
#    model.
#
# 19.11.2006
#  - Added to_bash method.
#
# 05.12.2006
#  - Bug fixing and lessened the verbosity. 
#
# 19.12.2006
#  - Implemented dumping of Recipes and using them as a 
#    standalone .rb file.
#
# 28.03.2007
#  - Check if file_exists at specified location. If not,
#    dont continue.
#
# 16.04.2007
#  - Renamed class.
#
# 19.06.2007
#  - added 'all' to compile everything no matter what ;)
#
# 24.07.2007
#  - fixed bug with extract_to where it was invoked two times
#    instead of just once, and added use_this_program_name as
#    alternative name for a program.
#
# 07.08.2007
#  - Since today, all '-' from ARGV will be stripped.
#
# 24.08.2007
#  - Added new compile_how option, so that we can use even
#    unusual "traditional:" datasets.
#  - Changed initialize so that the input you give it is now 
#    split after passing a '-', so gcc-1.2.4 will in fact just become
#    gcc. Note that I might change this behaviour one day if
#    there is a good reason (like compiling a specific program
#    instead), but I believe I will then make it modular, so that
#    the user can switch between the behaviour he wants and needs.
#
# 25.08.2007
#  - Created ChainedPrograms.rb which shall replace 
#    RYamlSourceWrapper one day.
#
# 31.08.2007
#  - Fixed a bug with guessed program names, which could also 
#    downcase a name when the user didn't want to do so ...
#
# 11.09.2007
#  - Added apply_patch method.
#
# 15.09.2007
#  - Added APPEND_VAR_LOCALSTATEDIR option
#
# 02.10.2007
#  - Added Slackware option. Means, you can now create slackware
#    packages.
#
# 08.11.2007
#  - Added finding Packages.
#
# 12.11.2007
#  - Started bug fixing where we create Ruby-dirs even though we dont
#    want to create such a dir, or the target is different. This is 
#    not yet complete though ...
#  - Renamed RYamlNewSourceMaker.rb to RSourceMaker.rb
#
# 01.12.2007
#  - Added Systemu to suppress boring STDOUT message (if systemu is 
#    available on a system).
#
# 07.12.2007
#  - Fixed double-adding of --prefix (which appeared under certain 
#    circumstances)
#
# 09.12.2007
#  - Outfactored code from RSourceMaker and created RConfigureString,
#    to have a decidated class handling all the various configure options.
#
# 23.12.2007
#  - Added log support (logging errors so far only)
#
# 25.03.2008
#  - Added --nocolour option to disable colour profile
#
# 13.04.2008
#  - Added option to check if a compiling is in process. This is quite dumb
#    right now because we just create a special file, it could be cached
#    or registered somewhere else. I will need to change this later probably.
#
# 17.04.2008
#  - Massive renaming and moving of files. That required fixing of maybe
#    80 files in total.
#
# 03.05.2008
#  - Added generic BUILD/ dir and changed all of cookbook.yml to use it
#    instead of name-specific build directories.
#
# 15.06.2008
#  - Added commandline option to build in a subdir --subdir
#
# 15.07.2008
#  - Added ability to always display required and recommended dependencies.
#
# 07.04.2009
#  - Added ability that you can compile a program if you only know the
#    binary name. (This setting can be changed in the config file). For
#    example, if you now do "compile xine-check", we will compile xine-ui.
#    Before this change, the software would have reported that it can not
#    find a program called "xine-check" in the cookbook file.
#
# 10.04.2009
#  - Added ability to compile a specific program, as in:
#      ry ruby wrap 7
#    This behaves equivalently to "chained ruby 7"
#
# 18.04.2009
#  - Added new commandline option "dc", short for "dont compile". If it
#    is given, then we extract, and run configure, but we actually do
#    not do make and make install.
#
# 12.07.2009
#  - We will now cleanup empty dirs if compilation somehow failed.
#
# 02.10.2009
#  - Renamed RSourceMaker to Installer.rb
#
# 04.04.2011
#  - Fixed bug where "ry gtk v?" was not working anymore. Did this by 
#    changing the Regex.
#
# 18.05.2011
#  - Changed name of @installs_these_binaries to @binaries
#
# 13.02.2012
#  - Deprecated class Installer and created class NewInstaller. Made
#    massive changes to the code.
#
# =========================================================================== #

# =========================================================================== #
# Changelog: Chained.rb
# =========================================================================== #
# 14.02.2011: Since today day, if we pass an array to this class, then we 
# check if its members have a '-' and a number. If yes, then we split it 
# up nicely with proper versioning.
# =========================================================================== #

# =========================================================================== #
# Changelog: RConfigure.rb
# =========================================================================== #
# 25.02.2011: Added a way to set a specific version.
# =========================================================================== #

# =========================================================================== #
# Changelog: SharedCode.rb
# =========================================================================== #
# 12.04.2008: Renamed SharedCode to RubyBuildTools_SharedCode.rb
# 02.10.2009: Renamed it to RBT_Base.rb
#   Jul 2012: Back to shared.rb again.
# =========================================================================== #

# =========================================================================== #
# Changelog: RPackages.rb
# =========================================================================== #
# 02.10.2007: Added Slackware .tgz package creation.
# =========================================================================== #

# =========================================================================== #
# Changelog: AdvancedSymlink.rb
# =========================================================================== #
# 09.09.2006: Added resymlink option
# 25.11.2006: Reenabled symlinking of .pc files.
# 05.09.2007: Cleanup of requires.
# 08.11.2007: Remove a little bit code and a lot of comments
# 03.01.2008: Renamed to RAdvancedSymlink.rb and also changed internals
# 24.09.2008: Added relative ../ symlinking
# 16.03.2011: Added "rnsmyc /p/ffmpeg" including the sanity checking as valid
#             argument.
# 15.07.2011: When AdvancedSymlink.rb is run, it will also register into
#             the yaml database.
# =========================================================================== #

# =========================================================================== #
# Changelog:  CreateProgram.rb
# =========================================================================== #
# 03.09.2005: Passed program_name will be downcased
# 27.09.2005: Main class handles the input properly. Also adds Version.
# 29.09.2005: Now supports that you can pass additional
#             directories which get created.
# 01.10.2005: Included ArgvSplitter to have an easier ARGV handling 
#             available. (Note: ArgvSplitter was lateron removed again)
# 10.05.2006: Some minor changes so that we use std_system.rb more now.
# 28.08.2006: Removed ARGV Splitter again.
# 01.06.2006: Made it less verbose so that a user will recieve less
#             "info spam" from this class.
# =========================================================================== #

# =========================================================================== #
# Changelog: CookbookLoader.rb
# =========================================================================== #
# 14 JAN 2006
#   - Creation of RYamLoader.rb.
#
# 20 FEB 2006
#   - removed @interlinked_programs, changed it to become 
#             @chained_programs instead
# 12 MAR 2006
#   - removed logging capability of this file. Other files will do the 
#     logging, this file only provides the sanitized data from the yaml file.
# 17 MAR 2006
#   - added is_a_game? to find out if the program is a game or is not.
# 29 MAR 2006
#   - added keep_extracted
# 08 JUL 2006
#   - Added RINSTALL to SharedData and adapted RYamlAccessor.rb to use
#     this info as well in sanitize_my_information
# 12 AUG 2006
#   - Added better support for error message (more info).
# 21 SEP 2006
#   - Made program_description output on console look 
#     nicer, ie properly indented etc.
# 18 NOV 2006
#   - Added to_bash which will create a file that bash understands.
#     However, I also moved to_bash to RSourceMaker.rb after
#     I realized that this is quite a big task which should 
#     be handled by RSourceMaker.rb instead.
# 27 FEB 2007
#   - Added use_this_make_command option to use cmake and qmake in 
#     addition to traditional make. 
# 08 APR 2007
#   - Added that you may use 'f' instead of 'false' in traditional
#     same with t and true. I will probably extend this to all 
#     the settings.
# 30 APR 2007
#   - Added marshal dumping (+updating) and loading of this data.
#     Reason is mostly to gain a little speedup. However this 
#     currently has a slight bug... debugging will take longer :(
# 31 MAY 2007
#   - Added use_this_build_directory to specify a special, alternative
#     build directory. (Will default to the name "BUILD/" if 
#     no alternative name is given. Personally I recommend to always
#     stick to the uppercased "BUILD/" name)
# 08 JUN 2007
#   - Added @do_not_symlink to avoid automagic symlinking. This may
#     be useful if you want to compile i.e. glibc, without doing an 
#     automatic symlinking (as this might break your system etc..)
# 21 SEP 2007
#   - Added ability for use to dump his own programs into a new 
#     yaml file via generate_custom_yaml, and also added the generation
#     handler into RSourceMaker. Then renamed RYamlLoader to
#     RYamlAccessor.
# 28 SEP 2007
#   - Added recommended_deps_on as a new option and changed 
#     important_deps_on to recommended_deps_on.
# 09 OKT 2007
#   - Small fix with feedback_urls. Now, empty URLs wont be
#     fed to the user.
# 16 OKT 2007
#   - Added KERNEL_V Macro to archive_name
# 09 MAR 2008
#   - Massive overhaul, renamed to RCookbookLoader.rb
# 18 MAR 2008
#   - Disabled HUGE code portions and created a new class. It is no longer
#     possible to directly query CookbookLoader for data it stores. All 
#     queries need to be done via the new class Query.rb. This class will 
#     lateron also be extended to Query data from a database.
# 15.03.2009
#   - Added a way to feedback the local location of a program, i.e. where
#     it is stored.
# 27.06.2009
#   - Changed name from RCookbookLoader to CookbookLoader
# Jul 2012:
#   - I think this file here (CHANGELOG.md) is no longer really needed.
# =========================================================================== #

# =========================================================================== #
# Changelog: InstallPackage.rb
# =========================================================================== #
# 14.10.2007
#  - You can now symlink into specific directories. Will work on 
#    automatic symlinking from that later.
# =========================================================================== #

# =========================================================================== #
# Changelog: RawDataLoader.rb
# =========================================================================== #
# 22.08.2008: 
#  - Added ability to load several .yml files.
# Jul 2012:
#  - This class is no longer needed.
# =========================================================================== #

# =========================================================================== #
# Changelog: ChainedCompiling.rb
# =========================================================================== #
# 15.10.2007:
#  - Started this class (used to be called RChainedPrograms.rb).
# 08.11.2007: 
#  - Improved HTML feedback reporting. Also added this to diamond shell.
# 09.10.2008:
#  - Outfactored the URL feedback stuff into a new class (FeedbackInformation.rb)
#    It simply was too messy to keep both compiling and feedback in one class.
# 10.03.2009:
#  - Added ability to report the size of the programs in our compile chain.
# 08.04.2009:
#  - Added ability to compile program-positions. "chained xorg_apps 3" would
#    compile the third program of our xorg_apps chain.
# 02.09.2009:
#  - Renamed RChainedPrograms.rb to ChainedPrograms.rb

# =========================================================================== #
# Changelog: FeedbackInformation.rb
# =========================================================================== #
# 11.04.2011: Added shortcut help - if this file is called with the argument
# 'all' then we will feedback help for every available program.

# =========================================================================== #
# Changelog: Information.rb
# =========================================================================== #
# 10.06.2007: Creation Date of Information.rb

# =========================================================================== #
# General RBT-related Changelog:
# =========================================================================== #
# 12.11.2008: Created RawDataLoader.rb
#
# 20.04.2009: Created AliasShower.rb
#
# 29.04.2009: Created SourceDefinition.rb
#
# 01.10.2009: Renamed a LOT of files and tried to make the code smoother.
#
# 02.10.2009: Continued the above task. That was the most massive renaming
#             that was ever done in the RBT-project.
#
# 30.04.2011: Added LocalCheckForLatest.rb
#
# 06.06.2011: Started to use GIT for this project. But incomplete ...
#
# 29.02.2012: Rewrote the whole RBT project and renamed it to BT. Made
#             changes to ALL .rb files. Hopefully the codebase is
#             better now.
#
# 12.06.2012:
#
#  - Completely rewrote all of RBT, again. This time, I splitted it
#    up into two separate projects during the rewrite:
#
#      (1) Cookbooks project and the
#      (2) RBT Project.
#
# 15.08.2014: Added class RemoveAllSymlinks. Also, the project was again
#             renamed from BT to RBT. RBT really is a better name
#
# 28.08.2015: And started another rewrite from scratch. No longer using
#             git either.
#
# 11.12.2015: Added rbt_config --disable-colours so that we can disable
#             the colours globally now.
#
#  July 2017: Support for the clang compiler was added.
#
#  Dec  2017: Rewrote class RBT::CreateProgram and also rewrote the
#             internal logic of RBT, in particular to avoid running
#             through the same main loop twice.
#
# 04.09.2018: Merged RBT and Cookbooks into one project again. Weird
#             how 6 years ago the projects were split up.
# =========================================================================== #