This document describes the libtool component of the gem rbt.

Libtool itself is a truly awful shell script (predominantly a shell
script).

It makes assumptions that can very often turn out to be incorrect,
for instance when it hardcodes absolute paths into .la files (since
it assumes that everyone uses lib-dirs such as /usr/lib/ - apparently
versioned AppDirs such as /Programs/Sed/4.1.3/ is a thing that the
libtool creators have never bothered to want to use or think about).

Since these assumptions are very often false, or will break when you
relocate these .la files to a new position (what a weird way to design
this "robust" system, isn't it?), I have created a project written in
ruby that shall help me correct libtool-related problems of various
sorts.

Note that the code written under the Libtool namespace in itself will
not fix libtool. Libtool can not be fixed - it has to be deprecated.
But until that day, we need to workaround its limitations - and this
is exactly why this project here exists.

If you wish to completely purge a specific entry from a .la file at
hand, you can use this commandline invocation:

    --remove-this-entry=/usr/lib/libpng16.la

This would remove the entry /usr/lib/libpng16.la from all .la files 
that include them. (Yes, it works on all .la files because that is
the most common use case I am using.)

You can also omit the first part and actually input only the part
"/usr/lib/libpng16.la" - this is indeed enough. So you can omit
"--remove-this-entry=" altogether.

Note that we will scan through a set of directories to search through,
based on a yaml file. You can either manually modify this yaml file,
if you wish to use a different set of directories, or you can use a
commandline switch to do so - see the invocation "rubylibtool --help",
or whatever alias you may use to invoke this script. (It can obviously
not use the bin/libtool name because libtool may already use that name.)

I am willing to make extensions/modifications to this code so that it
becomes more useful for other people as well.

For more information about why libtool is so awful and has to go away,
have a look at:

  https://wiki.gentoo.org/wiki/Project:Quality_Assurance/Handling_Libtool_Archives
