This mail here shall primarily serve two different primary purposes:

(1) It shall a bit in what I was doing, primarily related to GoboLinux;
which is not much, but it may be better to just pick some start-time
rather than postpone ad-infinitum, so I'll arbitrarily pick today for
this, 21th of april 2019. 

(2) It is a first attempt as some kind of step-to-step "mini-tutorial"
for how to get RBT (rbt - the "ruby build tools") to work on GoboLinux.

As in particular the second part (2) may become outdated at a later time,
I will note down when I published this email:

    21.04.2019 (that is, 21st of April, 2019, in DD.MM.YYYY notation)

I will next proceed to describe on item (1):

-------------------------------------------------------------------------------
(1) I have several old computers here.

My main machine (desktop PC) is running a slackware-base system that was heavily
modified. There are two reasons why I use slackware as a base - for one, the
full DVD installation gives me a lot of programs to start with (and then 
replace with newer versions, anyway); and the other reason is that slackware 
gave me significantly fewer prolems than, say, debian, or fedora and so forth.

I still may use the latter ones for testing purposes; I even run fedora with
systemd (!) and GNOME3 on a laptop, to experiment with - but my main machine
is this desktop PC here.

From that point, I tend to compile almost everything from source, in a quite
brutal manner. Meaning, I have no real clue what I am doing, so I just try to
poke at things until they work (or I get bored and do something else, anyway).

Thankfully with the LFS/BLFS project, we have a project that really helps a
LOT. Lucas and Hisham probably know LFS/BLFS fairly well too.

For those of you who don't, here is the changelog, which I check every few
days to see if there is something new; and if there is, I may tend to 
update these programs too, improve the local description that I use, and
so forth. The URL to that changelog for the LFS/BLFS project can be found
here:

    http://www.linuxfromscratch.org/blfs/view/cvs/introduction/changelog.html

On my main desktop PC, I will try to, whenever possible, compile in a way
that is very similar to GoboLinux. Whenever possible, I will try to install
under the /Programs/ hierarchy.

For example, hisham's htop sits at /Programs/Htop/2.2.0/ and, as another
random example, Glib would sit at /Programs/Glib/2.60.1/.

My naming scheme is a bit different from GoboLinux, mostly because I am
quite lazy, so I tend to name everything downcased, and then the first
character is upcased, under /Programs/. The default naming scheme in
GoboLinux looks better than my schema, but one advantage that I can give
for the simpler schema is that I never have to think what the target
prefix may be on my own. I also once had a layout that was like this:

    /pkg/glib/version

But at some point I disliked it. I actually prefer the GoboLinux naming
schemata for some reason. Also note that my own personal preference is
mostly irrelevant as far as RBT is concerned - RBT will support any
naming schemata anyway (although ... I also have to admit that RBT in
its present form is a hack and quite buggy, but still).

There is another reason why I start with slackware, though, and why I
use a "hybrid" layout - and that is actually again laziness, or convenience
if you so will. I often lack knowledge how to fix something, such as
glib-schema files, or cmake-related parts that belong to KDE. When I use
the /usr/ hierarchy then things often just automagically work. It is
much uglier than the GoboLinux layout, but I also need to get things done
quickly on linux, so I often just don't have the time. There are also 
more resources available for the /usr/ prefix (e. g. LFS/BLFS), so this
is a reason why I actually use a hybrid system layout. When things can
be installed under /Programs/ then I happily accept that - but if things
don't, and if it is simpler to install into /usr/ then I'll do that too,
without problem.

In the long run I hope to reach a point where this will one day no 
longer matter, but right now, and probably for the ~imminent future,
I just keep on moving along on this hybrid system.

One part of GoboLinux, such as with rootless, I think, was also to 
allow for something similar; and with the creation of the .iso, too
(I forgot the name ... I can not find it at https://github.com/gobolinux
right now but I think there was some component for automatic creation
of packages, and/or testing, and creation of the .iso, but I can
not remember).

Anyway - the primary reason for the hybrid layout is just convenience,
also lack of time.

The hybrid layout brought a bit of success to me too.

For example, I am currently running the latest stable mate-desktop system,
and, surprisingly, it works very well - almost no problems. It also
looks better to me than xfce, although I like xfce too.

If any of you want to give it a try, have a look here:

    https://pub.mate-desktop.org/releases/?C=M&O=D

I use only 1.22 components:

    https://pub.mate-desktop.org/releases/1.22/?C=M&O=D

I tend to use this as compile layout for the mate-desktop:

    - matedesktop              # cmate1
    - libmatemixer             # cmate2
    - libmateweather           # cmate3
    - matemenus                # cmate4
    - matepanel                # cmate5
    - matenetbook              # cmate6
    - matemedia                # cmate7
    - marco                    # cmate8
    - libmatekbd               # cmate9
    - matesettingsdaemon       # cmate10
    - matecontrolcenter        # cmate11
    - matesensorsapplet        # cmate12
    - caja                     # cmate13
    - cajaextensions           # cmate14
    - engrampa                 # cmate15
    - eom                      # cmate16
    - mateutils                # cmate17
    - pluma                    # cmate18
    - mateterminal             # cmate19
    - matethemes               # cmate20

(cmate1, cmate2 etc... are just aliases that I use to "compile
mate1", "compile mate2" etc... I am so lazy that I use lots of
aliases to simplify compilation.)

This also brings me to the first example that I would like to
show via RBT - I will explain how to install it lateron, but
for now, just an example for the mate-desktop archive (the
first entry in the list above):


> rbt matedesktop --url?


Result will be:

    RBT::Cookbooks::Url: Seeking URLs to `matedesktop` next.
    url1: http://pub.mate-desktop.org/releases/1.22/mate-desktop-1.22.0.tar.xz
    url2: http://pub.mate-desktop.org/releases/?C=M;O=D

The above is output on the commandline. All these mate-desktop components
are registered in the RBT project. Anyway more on this later.

I also registered all KDE5 components - plasma, kde-applications, 
kde-framework. That was quite a lot of work, initially, but now that
these are registered, it is quite easy for me to update them via 
a few ruby scripts. In general, updating existing information is a
LOT simpler than adding new information. Perhaps some GoboLinux folks
can relate to this, e. g. when adding recipes to GoboLinux such as
here:

    https://github.com/gobolinux/Recipes

Since I mentioned this, that brings me to something else ... I thought
a bit about the recipe-situation. Some months ago, I think, I added a
bit of code to be able to autogenerate gobolinux-recipes. I didn't look
at the code for quite some time, due to many reasons; also because my
zsh/bash knowledge is quite limited, but I was wondering ...

We don't actually need the directory structure that the recipes rely
on, right? We could use yaml and/or json, in addition to this.

Perhaps this may help exchange recipes more readily. I haven't really
put much thought into this, but imagine if we'd have a recipe for,
say, htop, and a json file that describes it completely. That may 
make updating the recipes a bit simpler. (The shell-specific parts
are still a bit more complicated).

On that note, there is a package manager in ruby, by the way - perhaps
some of you know it, mac homebrew.

    https://brew.sh/

While it is aimed for a Mac, it also supports linux out of the box
since a few months. I tested it, perhaps 2 months ago or something
like that - it has a few buggy situations, but I think these will be
fixed eventually.

They use a hardcoded approach for getting programs to work, e. g. 
a given recipe will contain ruby code.

For example, on the above homepage, they show an example for
wget:

    class Wget < Formula

      homepage "https://www.gnu.org/software/wget/"
      url "https://ftp.gnu.org/gnu/wget/wget-1.15.tar.gz"
      sha256 "52126be8cf1bddd7536886e74c053ad7d0ed2aa89b4b630f76785bac21695fcd"

      def install
        system "./configure", "--prefix=#{prefix}"
        system "make", "install"
      end

    end

I am not sure how many of you here know ruby, but this is mostly just
ruby code, method calls, with some Strings denoting e. g. the
homepage to wget, the main URL, the sha256-sum, and a method
called install that, assumingly so, will run configure, make
and make install (or perhaps just "make install" ... not completely
sure).

Interestingly, the homepage states this:

    Homebrew installs packages to their own directory and then
    symlinks their files into /usr/local.

Which is somewhat similar to GoboLinux in a way. :)

Or perhaps the Mac-way, anyway.

To come back to KDE - actually, the most annoying part of the whole
KDE stack is ... qt (and qtwebengine). I had lots of problems with
qt in the past. But in general, if you manage to install qt, then
the rest should be simpler, even though KDE has so many components.

Not everything works perfectly well on my system here, but I am
running the latest KDE konsole and it works fine; okular works
too, most other things work as well, such as dolphin etc...

What actually does not work here is that I can not start KDE5 plasma
from runlevel 3 via .xinitrc. The KDE5 plasma screen loads up,
and the applications that I have under autostart/ also show up,
but the bottom menu pane is missing. No clue why that does not
show up. Getting the KDE-devs to improve that, e. g. to display
more useful error messages when things go awry, is pretty tedious
and a very slow process. KDE3 really was so much simpler in every
regard ... and while KDE5 + qt5 look more polished, I just can't
help feel that the trade-off isn't quite worth it really, considering
how much effort went into this all. But I digress.

In particular the mate-desktop should not be too difficult to set up
on GoboLinux, but I gave up after glib-related problems in regard
to docbook*. More on that later.

I will now go over to (2) and write the remainder of this as some
kind of a mini-tutorial.

-------------------------------------------------------------------------------
(2) This part will be the mini-tutorial. I will also explain what I tried to
do.

My initial goal was to get to test GoboLinux on a second computer, which so
happens to be one that is below this room. Meaning that it is a bit cumbersome
to go to it, since most of my work area is upstairs (but there isn't that 
much space, so getting another computer here is a bit cumbersome).

Anyway - I would install GoboLinux from the latest .iso (burned onto a DVD), and
then install it. Installation on that machine works really well; it's a machine
from 2014 and it was quite fast back then, so it still works decently well. I
also don't have any problem with the harddisc, since it has only 0.5TB; the
one here on my main PC has 3.0TB and I have to use elilo rather than lilo
(slackware still apparently struggles to provide grub2 by default).

So installing the latest GoboLinux worked without problem on that machine.

For reference purpose, this was the .iso I was using:

    https://github.com/gobolinux/LiveCD/releases/download/016.01/GoboLinux-016.01-x86_64.iso

Past this point of installation, I would initially do something like "Compile ruby",
although I guess InstallPackage could have also worked.

This would, however had, not install the latest ruby, and since I have run into
a few differences between that ruby, and the latest ruby, I actually recommend
to simply get the latest ruby from source, and install it. It is super-easy on
GoboLinux out of the box, so let's start with this here:

2a) Getting ruby to work on GoboLinux

The procedure is:

    wget https://cache.ruby-lang.org/pub/ruby/2.6/ruby-2.6.3.tar.gz
    tar -zxvf ruby-2.6.3.tar.gz
    cd ruby-2.6.3
    ./configure --prefix=/Programs/Ruby/2.6.3
    make
    make install
    SymlinkProgram ruby 2.6.3

After that, doing this:

    ruby --version

Should work and e. g. report a version like:

    ruby 2.6.3p62 (2019-04-16 revision 67580) [x86_64-linux]

Hopefully this step worked for those of you who want to try it.

It is almost simpler than "Compile ruby", too. ;)

I tested it and it works on a vanilla install of GoboLinux - at
the least on the computer downstairs. But I think it should work
for other people just as well.

Next, it is time for 2b - installing rbt.

2b) There are several ways, but the simplest one would be via 
"gem", and I also recommend a --user-install option. While there
are other possibilities, I found this one to work the best.

So issue the following commands if you will:

    gem install rbt --user-install

(You may have to use -f for force installation, such as
"gem install rbt --user-install -f", but for me the variant
with -f worked well.)

Everything should work to this point. The bin/ executables
are somewhere in the home directory.

Use something like this next:

    export PATH="~/.gem/2.6.0/bin/:$PATH"
 
See:

    https://guides.rubygems.org/faqs/

for reference.

Have a look at that .gem directory to find out the
exact name.

Once that works, you should be able to do this:

    rbt --version

This should show the version of rbt, like:

    0.6.98

Now - rbt by default is a bit annoying to use right now,
my apologies. Lots of things do not work, so we have
to get to adjust it a bit.

First, let's disable colours - the colours work ok on 
KDE konsole, but GoboLinux does not have KDE konsole
by default right now, so let's disable the colours:

    rbt --permanently-diable-colours

Next, we must set a new source directory. For the time
being I recommend /SRC/ but you can use any other directory.

I use /SRC/ for now since it is simple to navigate:

    mkdir /SRC/
    rbt --set-source-dir=/SRC

Then you can confirm that this is the source directory
via:

    rbt --source-dir?

The source-directory is where all source directories are kept.

Next - we can download htop via:

    rbt --download htop

But better would be:

    rbt --download-proper htop

This will create a subdirectory under /SRC/htop/ and then
download http://hisham.hm/htop/releases/2.2.0/htop-2.2.0.tar.gz
into that directory.

Actually, this is what RBT will also do if you try to compile
something from source.

Let's compile ccache.

Issue this command:

    rbt ccache --ntrad --use-gobolinux-symlink-program

Don't mind any warnings for the time being.

ccache will be downloaded and compiled into /Programs/Ccache/3.6

You can proceed to compile any other of the programs that are
registered that way, for the most part.

To query how many programs are presently registered in the RBT
project, try:

    rbt --n-programs?

The result would be something like:

3585 programs are registered in the RBT project as of 22.04.2019.

So, 3585 registered programs. Not bad. :)

It is also a good idea to update the GoboLinux Scripts collection
via:

    InstallPackage Scripts

This seems to require python 2.7.x though. I am not sure if the GoboLinux 
Scripts work with the latest python; I did not test it.

I should also say that my method is a "brute force" way; it is
not very elegant, not super-clean ... ideally you should compile
things in the GoboLinux way.





---
CONTINUE HERE

















At any rate - I would get the latest ruby to work on GoboLinux, then install
the various necessary gems, and from there slowly proceed to compile from
source - things such as binutils, coreutils, sed, awk, grep, make, gmp,
mpc, mpfr, eventually a recent python3, meson, ninja, nasm, flex, bison,
gcc eventually, and qt. The latter two taking more time.

I'd also want to install e. g. glib, gobject-introspection, atk, cairo,
pango, but glib wants docbook-related code, which annoyed me. Docbook*
annoys me in general, I hate that thing. A problem is that there are no
simple installation instructions.

The LFS/BLFS project has instructions documented of course:

http://www.linuxfromscratch.org/blfs/view/svn/pst/sgml-dtd.html

But the problem is - even afterwards it still does not seem to work 
overly well. And I don't like XML anyway, so I always end up investing
time into that thing, just to get other projects working ...

(It's also not just docbook alone but also docbookxsl, docbookutils,
docbook2x and docbook, although one of these is outdated I think. I
just hate that.)

Anyway - the reason why I just installed the latest ruby, and then
proceeded to work with my scripts alone is so that I can actually
test how this SHOULD work for other people by default, aka "out of
the box". And I managed to compile the first batch of programs
that I mentioned above, e. g. binutils, coreutils etc... all
without a real problem. So if I can do so, this means others should
be able to do so, too; and I may be able to eventually autogenerate
valid GoboLinux recipes as well.

This actually made me think about the GoboRecipes in general - would it
be a good idea to add an additional way to hold the whole content of a
gobolinux recipe? For example a single yaml file and/or json file?

This may be easier to publish for people. They could just even upload
it to gist.github alone, for inofficial stuff or something like that.

The official gobo-recipes would always be available, but one advantage
with a less restrictive policy may be that people could more easily
install gobo-recipes. (I understand that one issue is quality control,
but this may always be a trade-off e. g. ease-of-use versus amount
of people using/helping bootstrap things and get them going. With 
limited resources even maintaining different programs alone is quite
a lot of work; I notice this myself when I update programs that I 
wish to compile from source. I sort of try to keep this to a minimum
and update daily, using scripts to help me here, but sometimes it still
takes time to update which I do not always have available.)









Before I begin to explain what should/could be done here via RBT, allow me
to state that I finally tested the below instructions myself - meaning, the
steps that I describe below, actually have worked for me on a "vanilla"
GoboLinux setup. That is, a new GoboLinux installation, on an older computer
from 2014. That machine is "sitting" in my basement, so it's a bit cumbersome
going downstairs and working from there. Most of my work I do upstairs on
another machine. :P

Alright. Without further ado, step-by-step instructions follow next:

(This seems to require python 2.x rather than python 3.x, just to note.)

2) Next issue:

  Compile Ruby

We need some ruby available for RBT, logically; ideally the most recent
version of ruby, but an older one may do fine for the time being. The
instructions also show how to update to a newer ruby.

Keep in mind that things aren't quite polished as of yet when it comes
to RBT. 

At any rate, wait a bit until ruby is compiled successfully or do 
something else meanwhile.

Then, when it was finished:

3) Install rbt via:

  gem install rbt --user-install -f
  
We need the -f option for "force" because rbt is set up to work with the
latest ruby version; so via -f we ignore that check and just continue for
the time being.

After that make sure that:

  rbt --version

works and outputs some recent version.

Some warnings may be printed, which ... confuses me (this does not appear
on my home system). I will look into this at a later time but for now,
just make sure that you get some string output on the commandline such
as:

0.6.63

(Or any other higher version than that.)

Ok. Now we want to get to update ... ruby itself. We will use RBT for
this, though.

Before we do so, we first have to designate our base directory where we
will download source archives into, from the point of view of RBT.

For GoboLinux, the recommended one may be at /Depot/Files/ but pick
whatever other directory that you may want to use:

    rbt --set-source-dir=/Depot/Files

Ensure that this is correct via:

    rbt --sourcedir

(Ignore the warnings for now ... annoying).

One reason why this has to be done is that rbt presently requires a
single directory with a simple scheme to follow, that is, a program
such as "php", will also have a directory called php/. At some later
point in the future I may add more flexibility here, but for now,
this is how it has to be - apologies for any inconvenience due to
this.

Next, do this step:

  gem install sql_paradise --user-install  -f

(This will become optional in the future ... something is not properly
setup, but again, for the time being, ignore the issue if it is an
issue. :) )

Next, navigate to some directory and download ruby. Ideally you should
cd into the directory that you designated as the main source directory.

So in the case above, the directory /Depot/Files/.

cd into that directory, then mkdir ruby, then cd ruby:

    cd /Depot/Files
    mkdir ruby
    cd ruby

Next, issue the following command:

    rbt --download ruby
    (rbt --download=ruby would also work)

Now ruby has been downloaded, if all goes well. (It did work for me
on the vanilla GoboLinux, so it should also work for you too.)

Next, we compile that downloaded ruby - this is a bit ... clumsy
in rbt, since it currently does not allow for compilation of files
that are stored outside the "proper" directory structure :\ :/ -
but, ignore that for the time being, and just proceed to do:

    rbt ruby ntrad

    SymlinkProgram ruby 2.6.2

A warning for ccache may appear but you can ignore this too. You can
also disable the warning, but again, it's not so important.

(If you want to make use of ccache, try this first:

    cd  /Depot/Files
    mkdir ccache
    cd ccache
    rbt --download ccache
    rbt ccache ntrad
    SymlinkProgram ccache
    
(Unfortunately there is a small bug in RBT right now - normally rbt
does not require GoboLinux SymlinkProgram, but the bug makes this a
bit problematic for the time being; also in ruby 2.4.x, require 'pp'
is not optional, so this means that a few .rb files in rbt may fail
until you have upgraded to ruby 2.6.2 or something like that. I'll
get to fix the other bug eventually but I work in a pretty chaotic,
non-linear manner. It's a hobby project and ultimately a huge
hack ... )

Anyway. Let's make sure that ruby has been compiled successfully after
that step:

    ruby -v

Do not forget to also do:

    SymlinkProgram ruby 2.6.2

prior to that.

The version output should now be 2.6.2 something or later.

We also have to re-install rbt since we updated ruby:

    gem install rbt --user-install -f

    # sql_paradise for the time being too although
    # it is a bug that this is necessary... I'll fix
    # this at some later point.

    gem install sql_paradise --user-install -f

    # You can also install the roebe gem which has a few more
    # custom things, but it is not that important:

    gem install roebe --user-install  -f

In theory, re-downloading rbt may not be necessary, due to GoboLinux
using Alien (and the .rb files here are only text files, anyway,
nothing is compiled). One could even copy these .rb files from
/Programs/Ruby/2.4.2* something into /Programs/Ruby/2.6.2*
somewhere ... but this mail here is also very hackish, so we'll
just try to re-install route since it is much simpler than 
having to think through alternatives ... ;)

Ok ... what to do next? Well ... the RBT project has some +3540
programs registered so far, or so. And in theory, all of them could
be compiled/installed.

The whole idea of the rbt project is to be able to allow installation
of these programs on any (linux) system.

I use it on my home system since quite a long time, but I also know
its limitations, unsurprisingly, so ... it may not be ideal for your
use cases. But even the --download functionality alone is neat since
you can really download literally everything that is registered.

You can even download different versions that way.

Let me demonstrate this briefly with glibc, although I do not recommend
you to actually compile glibc - glibc is a bit annoying to upgrade,
compared to other programs. So this really is just a demonstration
of the download functionality:

    rbt --download glibc
    rbt --download glibc-2.28
    rbt --download glibc-2.27
    rbt --download glibc-2.26

The first variant will download the most recent glibc (if it is registered
in the RBT project). The other variants will specifically try another
remote URL. A simple guessing "algorithm" is used to infer which are
the different remote URLs in these cases (I can not even call it an
algorithm really since it is so dumb ... but it works quite ok, for
simple URLs; github-based URLs are a bit more problematic).

Anyway, --download can be used to download a registed program, and
you should end up with a downloaded copy of glibc in the current
working directory.

If you want to look at the yaml file for glibc, you can use this
commandline variant:

    rbt --show-all-about=glibc

Let's next try to update python, but keep in mind that GoboLinux may
need python version 2.7.12 (or some other 2.x), due to the use of
python in some of the GoboLinux Scripts - so retain the old python.
(2.7.12 is the one that is included in the last last official .iso
release of GoboLinux).

Let's try to get python 3.7.x something first, via:

    cd /Depot/Files
    mkdir python
    cd python
    rbt --download python
    rbt python ntrad
    SymlinkProgram python 3.7.3

(ntrad stands for "non-traditional" aka AppDir prefix; trad on the 
other hand would mean prefix /usr/. You could also use --ntrad or
--app_dir instead, if you would like to; I just prefer having to
type less).

At this point you may notice that the colours do not properly work when
used in the default terminal on GoboLinux. I am aware of the issue ...
well. I myself use KDE konsole and the colours are a lot better there.
But, for the time being, let's get rid of colours altogether since
they distract too much. (At a later point I may add simpler colours
which means to focus on simpler terminals too - so like only some 10
colours or so, but that may suffice):

    rbt --permanently-disable-colours

Ok ... let's continue that ...

If all went well then python 3.7.3 should now be installed. \o/

It worked on my base system in a vanilla setup of GoboLinux, so it
should hopefully work for other people too.

Let's install meson next because meson is needed for a few other programs:

    cd  /Depot/Files
    mkdir meson
    cd meson
    rbt --download meson
    rbt meson ntrad
    SymlinkProgram python 3.7.3

(meson requires python 3.x).

At this point it may also be useful to install the gem called 
environment_information. We actually no longer need the -f option
now when we make use of "gem install", since we have a recent
ruby, so we can just do:

    gem install environment_information

Amd then:

    envi --really-all --disable-colours

This should tell you which programs could be updated.

It does not track all programs, though, just the more important
ones - gcc, glibc, binutils and so forth. Also some xorg-related
programs. (If you see the display of mate-desktop components,
then this is from the roebe gem. I make use of different gems
to track what is available on a given computer system.)




















The following instructions are meant for the distribution called
GoboLinux - how to setup the RBT project for use in GoboLinux.

These instructions were last updated in January 2019.

--------------------------------------------------------------------------

(1) Updating Ruby

A recent ruby is required. You should compile ruby via the GoboLinux
tools, through:

    Compile ruby

If all goes well you should now have a somewhat recent ruby version
("ruby --version" should indicate the version in use).

The next step is to download the rbt project, via gem:

    gem install rbt

If all goes well you have finished the first task here, and we can
move to the second (2) stage.

--------------------------------------------------------------------------

(2) Specifying your system

The RBT project can download remote files and compile programs.

It needs to have two necessary directories defined, in order to properly
work; one is where to extract the downloaded tarballs to; and another
one to keep these archives stored at.

Let's define both - replace the directory with whatever directory you
want to use. We will use /Files/Archive/ for the purpose of this
document as our main archive directory:

    rbt --set-source-dir /Files/Archive/

(A trailing '/' is automatically appended, so you can omit the trailing
/ there if you would like to.)

Next, let's define the directory to which we will extract these archives:

    rbt --permanently-extract-to /Depot/Temp

Again, use whatever directory you want to use. If no value is
specified here then RBT will default to **/tmp/**.

Ok. The next step is to give this a try and compile some
program. More than 3000 programs are registered in the RBT
project, so you have a wide choice available at your
disposal.


You can download a remote program through either of the
following commands:

    rbt --download php

This will download PHP into the current working directory.

If you wish to place the php tarball into the "proper"
directory, the one rbt normally uses for compilation,
you can use the following instruction:

  rbt --download-into-proper-dir php





























TODO:

- also mention colour-make and --colour-make-install

- and mention support for meson and so forth


- add a way for displaying downloadable programs eg
rbt --show-downloadable-programs
rbt --downloadable-programs?
^^^ add ? and document it and mention it

- also store this in doc/GoboLinuxInstructions.md