This file will contain logical considerations for the RBT project.

- The RBT project should be able to give its users the possibility of
  either loading the dataset from a yaml file or from another file,
  specified on the commandline or via the API.

- The user of the RBT project should be able to query every information
  in a nice and convenient way. This is provided by the Cookbooks
  project, onto which RBT builds.

  For instance, we want to query whether a program has certain
  dependencies or not.

- Use the information from the Cookbooks project to Compile
  or Install packages. This should also be flexible.

- Finish the task by installing or compiling and then
  reporting to the user with information about this task.
  
The main RBT guidelines:

- STAY AS SIMPLE AS POSSIBLE, WHILE MAINTAINING AS MUCH
  FLEXIBILITY AS POSSIBLE.

- extract source

- start to compile, either via configure, scons or cmake

- check for errors:

  If no error, and installed into PROGRAMS dir, continue to 
  symlink

  If error, report to user and stop.

- if the installation was a success, register into database
  and register as last program compiled, too.

------------------------------------------------------------------------

For the compile-related action, the following logical steps may
have to be taken:

(1) Download the sources (skip if sources are already
    available locally).

(2) Extract the source archive.

(3) Ensure that the extracted archive exists and cd into
    it if it does not.

(4) Run autoconfigure if specified to do so.

(5) Run "configure" if a configure file exists. If an error
    happens during the configure step, we may not proceed
    into using any make command - use "do_not_use_any_make_step"
    for this.

See the file POST_CONFIGURE_LOGIC.md for steps past the configure
phase.

------------------------------------------------------------------------
