#!/System/Index/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'colours/autoinclude'
require 'rbt'
require 'cliner'
require 'verbose_truth/autoinclude'
e
e 'We will now test the various classes of the Cookbooks project.'
e
e 'Stay tuned.'
e
e 'The home directory is at:'
e
e "  #{sfancy(RBT.home_dir?)}"
e
e 'The project base directory is at:'
e
e '  #{sfancy(RBT.project_base_dir?)}"
e
e 'The project yaml directory is at: '
e
e '  '+sfancy(RBT.project_yaml_dir?)
e
e 'The cookbooks configuration directory is at:'
e
e '  '+sfancy(RBT.cookbooks_configuration_dir?)
e
e 'The individual cookbooks are kept here:'
e
e '  '+sfancy(RBT.individual_cookbooks_directory?)
e
e 'The configuration that will be used is:'
e
pp RBT.configuration?.system_directory
e
cliner
e 'Next, we try to find out whether the above has correctly'
e 'defined several constants:'
begin
  array = [
    RBT::CHECK_FOR_BINARY_NAMES,
    RBT::CHECK_FOR_LIBRARY_NAMES,
    RBT::STORE_INTO_THIS_DIRECTORY
  ]
  array.each {|entry| e "  #{entry}" }
rescue Exception => error
  p error; p error.class
end
e "The system directory is: #{sfancy(RBT.system_directory?)}"
e
e 'The PII hash constant is having this dataset (we show only one entry):'
pp RBT.pii?.fetch 'RINSTALL4'
e
cliner
e
e 'RBT.cookbook_aliases (A hash)'
pp 'vesa  -> '+RBT.cookbook_aliases['vesa']
pp 'xfwm  -> '+RBT.cookbook_aliases['xfwm']
pp 'xfce4 -> '+RBT.cookbook_aliases['xfce4']
e '^^^ The above were 3 entries fom RBT.cookbook_aliases'+"\n\n"
# Testing Cookbooks.find_url_for() next.
e 'Next we will find the URL for php:' 
e '  '+sfancy(RBT.find_url_for('php'))
e
cliner
e 'The available utility scripts are:'
RBT.show_available_utility_scripts
cliner
e
# =========================================================================== #
# Testing class Highest here.
# =========================================================================== #
cliner {
  e 'Testing class Highest next:'
}
RBT.highest :display_twenty_programs
cliner; e
# =========================================================================== #
# Testing class BLFS here (which gives us the link of the BLFS entry).
# =========================================================================== #
cliner {
  e 'Testing class BLFS next (input is: curl):'
}
RBT.blfs 'curl'
cliner; e
# =========================================================================== #
# Testing class AllUrls next.
# =========================================================================== #
cliner {
  e 'Testing class AllUrls next:'
}
RBT.all_urls
cliner; e
e 'Next we will test individual cookbook-entries:'
e
# =========================================================================== #
# === test_this_input
#
# With this method we can test the compilation.
# =========================================================================== #
def test_this_input(i)
  i = i.to_s
  _ = RBT::Cookbooks::Cookbook.new(i, :dont_run_yet)
  _.be_verbose
  _.full_report
  _.run
  e 'Is '+sfancy(i.to_s)+' included? '+vt(_.is_included?)
end
test_this_input :parted
test_this_input :libparted

e 'Next testing the individual Cookbook:'
cookbook = RBT::Cookbooks::Cookbook.new('ruby')
cookbook.feedback_make_options

object = RBT::Cookbooks::Cookbook.new('jpeg')
# =========================================================================== #
# === test
# =========================================================================== #
def test(*i)
  i.flatten.each {|name|
    dataset = RBT::Cookbooks::Cookbook.new(name)
    dataset.report # Invoke .report to report the dataset.
  }
end
e 'Now testing the project called '+sfancy('sanitize_cookbook_dataset')+'.'
# =========================================================================== #
# Test five entries next.
# =========================================================================== #
array = %w(
  php ruby htop libx11 xterm
)
e 'We will test this array next:'
pp array
test array
e sfancy('Next, we will test some setters and other methods:')
e
e simp('First, determine whether we will keep the archive '\
       'extracted or whether we will not.')
dataset = RBT::Cookbooks::Cookbook.new('htop')
pp dataset.keep_extracted?
dataset.keep_extracted = false
pp dataset.keep_extracted?
e
e 'The file called registered_cookbook_entries.yml is stored here:'
e '  '+sfile(RBT::Cookbooks::Cookbook.file_registered_cookbook_entries)
e
e ::Colours.orange('Next testing '\
  'SanitizeCookbookDataset.feedback_all_available_formats')
RBT.feedback_all_available_formats
e
# =========================================================================== #
# === Show the main URLs of the program:
# =========================================================================== #
e 'Next, we will show the main URLs:'
pp object.urls?
e
e 'The available help options are:'
e
RBT::Cookbooks::Cookbook.new('--help')
e